Graphics 800,600,32,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()


; Load the images.
Dim iBlock(7)
For n=1 To 7
	iBlock(n)=LoadAnimImage("system/"+n+".png",32,32,0,16)
Next

Global iBrick=LoadImage("system/brick.png")
Global iBG1=LoadImage("system/bg1.png")
Global iBG2=LoadImage("system/bg2.png")

Global iDropMe=LoadImage("system/dropme.png")

SetFont LoadFont("system/Visitor TT1 BRK.ttf",42)

; Each block's data.
	Dim BlockX(7,4,4), BlockY(7,4,4), BlockN(7,4,4)
; Temporary, just for reading the block data.
	Dim count(4), ox(4), oy(4)
; Grid Area
	Dim Grid(25,28)


Gosub GetBlockData

Dim Fits(5)	;Used in CanFit and FitMe


Dim Bag(28)
Global BagPos

NewBag()

.Prepare_Start
For x=0 To 25
	For y=0 To 28
		Grid(x,y)=1	; Where 1 = a bounding wall, 0 = nothing, and anything else will be block tiles.
		If x>4 And x<15 And y<23 Then grid(x,y)=0
	Next
Next



Global PlayerX=10
Global PlayerY=5

ABlock=FromBag()
Global PlayerRotate=((ABlock-1)/7)+1
Global PlayerBlock=((ABlock-1) Mod 7)+1

ABlock=FromBag()
Global NextRotate=((ABlock-1)/7)+1
Global NextBlock=((ABlock-1) Mod 7)+1


Global LetGo=0

Global CheckforLines=0
Global DropLines=0

Global DropDelay=0
Global DropSpeed=30

Global LandDelay=0
Global LandSpeed=20

Global MoveDelay=15
Global MoveSpeed=15
Global MoveNextSpeed=15


Repeat
Cls

TileBlock iBG1,0,0 

Viewport 4*32,0*32,12*32,600
TileBlock iBG2,0,0

Viewport 0,0,800,600
	
	; Draw the playfield
	For x=0 To 25
	For y=0 To 28
		If x>3 And x<16 And y>4 And y<24
			If Grid(x,y)=1 Then DrawImage iBrick,x*32,(y-5)*32	; Bricks
			If Grid(x,y)=2 Then DrawImage iDropMe,x*32,(y-5)*32	; Vanishing Blocks	
			If Grid(x,y)>99 	; Blocks
				image=Grid(x,y)/100	
				piece=Grid(x,y) Mod 100
				DrawImage iBlock(image),x*32,(y-5)*32,piece
			EndIf
		EndIf
	Next
	Next

	If CheckForLines=0 And DropLines=0
	
		For n=1 To 4	; Draw the player's piece.
			AtX=(BlockX(PlayerBlock,n,PlayerRotate)+PlayerX)*32
			AtY=((BlockY(PlayerBlock,n,PlayerRotate)+PlayerY)-5)*32
			DrawTile=BlockN(PlayerBlock,n,PlayerRotate)
			DrawImage iBlock(PlayerBlock),AtX,AtY,DrawTile
		Next
		
			; Left and right.
		;If KeyHit(203) And LetGo=0 Then PlayerX=PlayerX-1
		;If KeyHit(205) And LetGo=0 Then PlayerX=PlayerX+1
	
		If KeyDown(203) And MoveDelay>MoveSpeed And CanMove(-1) Then LandDelay=0:MoveDelay=0:MoveSpeed=MoveNextSpeed:PlayerX=PlayerX-1:MoveNextSpeed=2
		If KeyDown(205) And MoveDelay>MoveSpeed And CanMove(1) Then LandDelay=0:MoveDelay=0:MoveSpeed=MoveNextSpeed:PlayerX=PlayerX+1:MoveNextSpeed=2
	
		If KeyDown(203) Or KeyDown(205) Then MoveDelay=MoveDelay+1
		If KeyDown(203)=0 And KeyDown(205)=0 Then MoveDelay=15:MoveSpeed=15:MoveNextSpeed=15
	
	
		If Below()=0
			DropDelay=DropDelay+1	; Drop
			If KeyDown(208) And LetGo=0  Then DropDelay=DropDelay+((DropSpeed/2)+1)
			If DropDelay>DropSpeed Then PlayerY=PlayerY+1:DropDelay=0
		EndIf
		
		If Below()	; Landing
			LandDelay=LandDelay+1
			If LandDelay>LandSpeed
			
				For n=1 To 4
					grid(PlayerX+BlockX(PlayerBlock,n,PlayerRotate),PlayerY+BlockY(PlayerBlock,n,PlayerRotate))=(100*PlayerBlock)+BlockN(PlayerBlock,n,PlayerRotate)
				Next
				
				PlayerX=10:PlayerY=5

				LetGo=1
				CheckForLines=1

				PlayerRotate=NextRotate
				PlayerBlock=NextBlock
				ABlock=FromBag()
				NextRotate=((ABlock-1)/7)+1
				NextBlock=((ABlock-1) Mod 7)+1				
			EndIf		
		EndIf
		
			; Rotate
		fit=0
		If KeyHit(44) And CanFit(PlayerRotate-1) And LetGo=0 Then PlayerRotate=PlayerRotate-1:fit=1
		If KeyHit(45) And CanFit(PlayerRotate+1) And LetGo=0 Then PlayerRotate=PlayerRotate+1:fit=1
		If PlayerRotate=0 Then PlayerRotate=4
		If PlayerRotate=5 Then PlayerRotate=1
		If fit=1 Then FitMe()
		

	
	EndIf
	
	
	If CheckForLines=1
		CheckForLines=0
		DropLines=0
		
		For y=5 To 22
			FullLine=1
			For x=5 To 14
				If Grid(x,y)=0 Then FullLine=0
			Next
			
			If FullLine=1
				DropLines=1
				For x=5 To 14
					Grid(x,y)=2
				Next				
			EndIf
			
		Next
		
	EndIf
	
	
	If DropLines>0
		DropLines=DropLines+1
		If DropLines=15
			For y=22 To 5 Step -1
				Repeat	;Loop till we've no more filled lines here.
				If grid(5,y)=2	; If we do have a filled line here,
					For z=y To 5 Step -1
						For x=5 To 14  ; drop everything above it down a bit.
							Grid(x,z)=grid(x,z-1):Grid(x,z-1)=0
						Next
					Next
				EndIf
				Until grid(5,y)<>2
			Next
			DropLines=0
		EndIf
	EndIf
	
	
	
	For n=0 To 12
		Color 0+Sin(n*15)*255,0,0
			; where 0*15=0, 12*15 = 180, so we pass 180 degrees of a sin curve.
			; sin(0*15)=0 *200 = 0, sin(6*15)=1 *200 = 200, sin(15*15)=0 *200 = 0
		
		Rect 576-n,64-n,128+n*2,128+n*2,0
			; Box starts at 18*32,2*32 and extends 4x4 tiles.
	Next
	
		For n=1 To 4	; Draw the player's next piece.
			AtX=(BlockX(NextBlock,n,NextRotate)+(18+2))*32
			AtY=((BlockY(NextBlock,n,NextRotate)+(2+2)))*32
			DrawTile=BlockN(NextBlock,n,NextRotate)
			DrawImage iBlock(NextBlock),AtX,AtY,DrawTile
		Next
		
		Color 255,0,0
		Text 18*32+4,1*32-8,"N"
		Text 19*32+4,1*32-8,"E"
		Text 20*32+4,1*32-8,"X"
		Text 21*32+4,1*32-8,"T"
	
	If KeyDown(208)=0 And KeyDown(203)=0 And KeyDown(205)=0 And KeyDown(44)=0 And KeyDown(45)=0 Then LetGo=0
	
Flip
If KeyDown(1) Then endofgame=99
Until endofgame<>0


End





.GetBlockData	
	For b=1 To 7	; Each block.
	
		For n=1 To 4	; Clear our temporary data for the next block.
			count(n)=0
			ox(n)=0
			oy(n)=0
		Next
	
		For y=1 To 4			; Each line
			For r=1 To 4		; Each rotation
				Read in$		; read chunk
				For x=1 To 4	; Each chr inside the chunk.
				
					i=Asc(Mid$(in$,x,1))
					
					If i>64 And i<91	; If a Capital letter
						count(r)=count(r)+1		; Next Tile.
						BlockX(b,count(r),r)=x	 
						BlockY(b,count(r),r)=y
						BlockN(b,count(r),r)=i-65
						ox(r)=x:oy(r)=y			; Track OX and OY.
					EndIf
					
					If i>96 And i<123	; If a lowercase letter
						count(r)=count(r)+1		; Next Tile.
						BlockX(b,count(r),r)=x
						BlockY(b,count(r),r)=y
						BlockN(b,count(r),r)=i-97
					EndIf
					
				Next
			Next
		Next
		
		For r=1 To 4	; Flip through all tiles
			For n=1 To 4	; And move, based upon ox and oy.
				blockX(b,n,r)=blockX(b,n,r)-ox(r)
				blockY(b,n,r)=blockY(b,n,r)-oy(r)
			Next
		Next
	Next
Return

; O
Data "0000","0000","0000","0000"
Data "0ac0","0ac0","0ac0","0ac0"
Data "0iK0","0iK0","0iK0","0iK0"
Data "0000","0000","0000","0000"
; I
Data "00d0","0000","00d0","0000"
Data "00h0","0000","00h0","0000"
Data "00H0","mnNo","00H0","mnNo"
Data "00l0","0000","00l0","0000"
; J
Data "00d0","0000","0ao0","0000"
Data "00H0","0mNc","0H00","0d00"
Data "0mk0","000l","0l00","0iNo"
Data "0000","0000","0000","0000"
; L
Data "0d00","0000","0000","0000"
Data "0H00","00d0","0mc0","aNo0"
Data "0io0","mNk0","00H0","l000"
Data "0000","0000","00l0","0000"
; Z
Data "0d00","0000","0d00","0000"
Data "0iC0","00an","0iC0","00an"
Data "00l0","0mK0","00l0","0mK0"
Data "0000","0000","0000","0000"
; S
Data "00d0","0000","00d0","0000"
Data "0aK0","0mc0","0aK0","0mc0"
Data "0l00","00Io","0l00","00Io"
Data "0000","0000","0000","0000"
; T
Data "0000","0000","0000","0000"
Data "00d0","00d0","0mBo","0d00"
Data "0mJo","0mG0","00l0","0Eo0"
Data "0000","00l0","0000","0l00"




Function Below()
	out=0
	For n=1 To 4
		If grid(PlayerX+BlockX(PlayerBlock,n,PlayerRotate),PlayerY+BlockY(PlayerBlock,n,PlayerRotate)+1)>0
			out=1
		EndIf
	Next
Return out
End Function

Function CanMove(PlusX)
	out=1
	For n=1 To 4
		If grid(PlayerX+BlockX(PlayerBlock,n,PlayerRotate)+PlusX,PlayerY+BlockY(PlayerBlock,n,PlayerRotate))>0
			out=0
		EndIf
	Next
Return out
End Function

Function NewBag()
	For n=1 To 28
	Bag(n)=n
	Next
	For n=1 To 28	;For each card, one after the other, from left to right
		r=Rand(1,28)	;Pick another random card on the table.
		t=Bag(n)		
		Bag(n)=Bag(r)	;Swap the two cards.
		Bag(r)=t
	Next
	BagPos=1
End Function

Function FromBag()
	out=Bag(BagPos)
	BagPos=BagPos+1
	If BagPos>28 Then NewBag()
	Return out
End Function


Function CanFit(Rotation)
	; Ensure we're still between 1 and 4.
	If Rotation=0 Then Rotation=4
	If Rotation=5 Then Rotation=1
	
	For n=1 To 5	; Reset Fits.
		fits(n)=1	; If anything blocks, we immediately set to 0.
	Next
	
	;Next, check all positions.  If any block's tile is atop 
	For x=-2 To 2
	For n=1 To 4
		atx=blockX(PlayerBlock,n,Rotation)+PlayerX+x
		aty=blockY(PlayerBlock,n,Rotation)+PlayerY
		If atx>0 And atx<25 And aty>0 And aty<28
			If grid(atx,aty)>0 Then fits(x+3)=0
		EndIf
		If atx<1 Or atx>24 Or aty<1 Or aty>27 Then fits(x+3)=0	; Just incase!
		
	Next
	Next
	
	
	;And last, check all fits to see if any are still 1.  Store in "out" then return out..
	out=0
	For n=1 To 5
		If fits(n)=1 Then out=1
	Next
	Return out

End Function

Function FitMe()	
	For n=1 To 5	; Reset Fits.
		fits(n)=1	; If anything blocks, we immediately set to 0.
	Next
	
	;Next, check all positions.  If any block's tile is atop 
	For x=-2 To 2
	For n=1 To 4
		atx=blockX(PlayerBlock,n,PlayerRotate)+PlayerX+x
		aty=blockY(PlayerBlock,n,PlayerRotate)+PlayerY
		
		If atx>0 And atx<25 And aty>0 And aty<28
			If grid(atx,aty)>0 Then fits(x+3)=0
		EndIf
		If atx<1 Or atx>24 Or aty<1 Or aty>27 Then fits(x+3)=0	; Just incase!
		
	Next
	Next
	
MoveX=0

;Check the two extents
If fits(1)=1 Then MoveX=-2
If fits(5)=1 Then MoveX=2

;Then check the middley bits
If fits(2)=1 Then MoveX=-1
If fits(4)=1 Then MoveX=1

; And last the absolute middle.
If fits(3)=1 Then MoveX=0

; Sorted!!
PlayerX=PlayerX+MoveX

End Function